VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPoly"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsPoint"
Attribute VB_Ext_KEY = "Member0" ,"clsPoint"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection

'Public Variables
Public canvas As Form
Public Color As Long
Public parent As clsSurface
Public this As clsPoly
Public Zorder As Double
Public prv As clsPoly
Public nxt As clsPoly

'Private Variables
Private SideOut As Integer
Public Function Add(PtNo As Long)
  mCol.Add PtNo

End Function

Public Property Get Item(vntIndexKey As Variant) As Long
Attribute Item.VB_UserMemId = 0
  Item = mCol(vntIndexKey)

End Property



Public Property Get Count() As Long
    Count = mCol.Count

End Property


Public Sub Remove(vntIndexKey As Variant)
    mCol.Remove vntIndexKey

End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]

End Property


Private Sub Class_Initialize()
  'creates the collection when this class is created
  Set mCol = New Collection
  
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub


Public Sub Show()
  Dim Brush As Long
  Dim Pen As Long
  Dim arPts() As POINTAPI
  Dim intX As Integer
  Dim retVal As Long
  
  On Error GoTo err_routine
  
  ReDim arPts(mCol.Count - 1) As POINTAPI
  
  'build the array
  For intX = 1 To mCol.Count
    arPts(intX - 1).X = CLng(parent.reference.X + parent.Point(CLng(mCol.Item(intX))).X):
    arPts(intX - 1).Y = CLng(parent.reference.Y - parent.Point(CLng(mCol.Item(intX))).Y)
  Next
  
  Pen = MakePen(0)    'Black Pen
  Brush = MakeBrush(Color)
  
  retVal = SelectObject(canvas.hdc, Pen)
  retVal = SelectObject(canvas.hdc, Brush)

  retVal = Polygon(canvas.hdc, arPts(0), mCol.Count)
  
  DelObject Pen
  DelObject Brush
  
  If (Not nxt Is Nothing) Then
    shown = shown + 1
    nxt.Show
  End If
  
  Exit Sub
err_routine:
  MsgBox "Error " & Err.Number & ", " & Err.Description
  
  
End Sub

Public Sub SetSideOut()
  Dim Vector1 As clsPoint
  Dim Vector2 As clsPoint
  
  Set Vector1 = New clsPoint
  Vector1.X = parent.Point(mCol.Item(1)).X - parent.Point(mCol.Item(2)).X
  Vector1.Y = parent.Point(mCol.Item(1)).Y - parent.Point(mCol.Item(2)).Y
  Vector1.Z = parent.Point(mCol.Item(1)).Z - parent.Point(mCol.Item(2)).Z
  
  Set Vector2 = New clsPoint
  Vector2.X = parent.Point(mCol.Item(3)).X - parent.Point(mCol.Item(2)).X
  Vector2.Y = parent.Point(mCol.Item(3)).Y - parent.Point(mCol.Item(2)).Y
  Vector2.Z = parent.Point(mCol.Item(3)).Z - parent.Point(mCol.Item(2)).Z
  
  
End Sub

Public Sub SetZord()
  Dim vntX As Variant
  
  Zorder = 0
  For Each vntX In mCol
    Zorder = Zorder + parent.Point(vntX).Z
  Next
  
  Zorder = CLng(Zorder)
  
End Sub

Public Function Sort()
  Dim nxtPoly As clsPoly
  Dim prvPoly As clsPoly
  
  On Error GoTo err_routine
  
  If (Not nxt Is Nothing) Then
    If (Zorder > nxt.Zorder) Then
      Set nxtPoly = nxt
      Set prvPoly = prv
      
      Set prv = nxtPoly
      If (Not nxtPoly Is Nothing) Then
        Set nxt = nxtPoly.nxt
      Else
        Set nxt = Nothing
      End If
      
      If (Not prv Is Nothing) Then
        Set prv.nxt = this
      End If
      
      If (Not nxt Is Nothing) Then
        Set nxt.prv = this
      End If
      
      If (Not prvPoly Is Nothing) Then
        Set prvPoly.nxt = nxtPoly
      End If
      
      If (Not nxtPoly Is Nothing) Then
        Set nxtPoly.prv = prvPoly
      End If
      
      Set prvPoly = Nothing
      Set nxtPoly = Nothing
      Sort
    End If
  End If
  
  If (Not prv Is Nothing) Then
    If (Zorder < prv.Zorder) Then
      Set nxtPoly = nxt
      Set prvPoly = prv
      
      Set nxt = prvPoly
      If (Not prvPoly Is Nothing) Then
        Set prv = prvPoly.prv
      Else
        Set prv = Nothing
      End If
      
      If (Not prv Is Nothing) Then
        Set prv.nxt = this
      End If
      
      If (Not nxt Is Nothing) Then
        Set nxt.prv = this
      End If
      
      If (Not prvPoly Is Nothing) Then
        Set prvPoly.nxt = nxtPoly
      End If
      
      If (Not nxtPoly Is Nothing) Then
        Set nxtPoly.prv = prvPoly
      End If
      
      Set prvPoly = Nothing
      Set nxtPoly = Nothing
      Sort
    End If
  End If
  
  Exit Function
err_routine:
  Stop
  Resume Next
  
End Function
