Attribute VB_Name = "Module1"
Option Explicit

'Type Declarations
Public Type POINTAPI
  X As Long
  Y As Long
End Type

'Global Constants
Public Const PS_SOLID = 0
Public Const PS_DASH = 1
Public Const PS_DOT = 2
Public Const PS_DASHDOT = 3
Public Const PS_DASHDOTDOT = 4
Public Const PS_NULL = 5
Public Const PS_INSIDEFRAME = 6
Public Const PI = 3.141592654
Public Const DEG_PER_RADIAN = (360 / (2 * PI))


'API Function Declarations
Public Declare Function CreatePen Lib "gdi32" _
(ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long

Public Declare Function CreateSolidBrush Lib "gdi32" _
(ByVal crColor As Long) As Long

Public Declare Function Polygon Lib "gdi32" _
(ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long

Public Declare Function SelectObject Lib "gdi32" _
(ByVal hdc As Long, ByVal hObject As Long) As Long

Public Declare Function DeleteObject Lib "gdi32" _
(ByVal hObject As Long) As Long

Global shown As Long

Public Function MakePen(c As Long)
  MakePen = CreatePen(PS_SOLID, 1, c)
End Function

Public Function MakeBrush(c As Long)
  MakeBrush = CreateSolidBrush(c)
  
End Function

Public Function DelObject(hObj As Long)
  DeleteObject hObj
End Function


Public Function lPad(Expression As Variant, _
                     Character As String, _
                     Length As Long) As Variant
  Dim l As Long
  Dim vBuf As Variant
  
  vBuf = ""
  For l = 0 To (Length - Len(Expression) - 1)
    vBuf = vBuf & Character
  Next
  
  lPad = Left(vBuf & Expression, Length)

End Function
